﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.801
@EndOfDesignText@
Sub Class_Globals
	Private s_URI As String
	Private s_DIR As String
End Sub
'Initializes the object. You can add parameters to this method if needed.
'Dir - directory containing the file location
'URI - the file name as a uri or standard file IE: A.jpg
Public Sub Initialize(Dir As String, URI As String)
	s_DIR = Dir
	s_URI = URI
End Sub
'Copies file to external location for manipulation
'ExternalLocation - the location to copie file to
'TargetFileNameandType - Target file name including file type IE: A.jpg
Public Sub ExtractTo(ExternalLocation As String, TargetFileNameandType As String) As Boolean
	
	Dim bB As Boolean = False
		
	If s_URI.Length <> 0 Then
		If ExternalLocation.Length <> 0 Then
			'Now check to see if it's a file that can be copied
			If GetFileExt(s_URI).Length <> 0 Then
				Dim fName As String = TargetFileNameandType
				File.Copy(s_DIR, s_URI, ExternalLocation,fName)
				If File.Exists(ExternalLocation, fName) Then
					bB = True
				End If
			Else
				Dim Inpute As InputStream = File.OpenInput(s_DIR, s_URI)
				Dim Outpute As OutputStream = File.OpenOutput(ExternalLocation, TargetFileNameandType, False)
				File.Copy2(Inpute, Outpute)
				Outpute.Close
				If File.Exists(ExternalLocation, TargetFileNameandType) Then
					bB = True
				End If
			End If 'GetFileExt
		End If 'ExternalLocation
	End If 's_URI
	
	Return bB
	
End Sub
'Trys to get file extension from a URI or File, If not then returns nothing
Public Sub GetFileExt(FullPath As String) As String
	Dim FileType As String = FullPath.SubString(FullPath.LastIndexOf(".")+1)
	If FileType.Contains("/") Or FileType.Contains("%") Then
		Return ""
	Else
		Return FileType
	End If
End Sub
'Gets the file name from URI
'URI = Uri string
Public Sub GetNamefromURI(column As String, uri As String) As String
	
	Dim results As String
	Dim Cur As Cursor
	Dim Uri1 As Uri
	Dim cr As ContentResolver
	cr.Initialize("")

	If uri.StartsWith("content://media/") Then
		Dim i As Int = uri.LastIndexOf("/")
		Dim id As String = uri.SubString(i + 1)
		Uri1.Parse(uri)
		Cur = cr.Query(Uri1, Null, "_id = ?", Array As String(id), Null)
		Cur.Position = 0
		If Cur.RowCount <> 0 Then
			For i = 0 To Cur.ColumnCount - 1
				If Cur.GetColumnName(i) <> Null Then
					If Cur.GetColumnName(i) = column Then
						results = Cur.GetString2(i)
						Exit
					End If
				End If
			Next
		End If
	Else
		Uri1.Parse(uri)
		Cur = cr.Query(Uri1, Null, Null, Null, Null)
		Cur.Position = 0
		If Cur.RowCount <> 0 Then
			For i = 0 To Cur.ColumnCount - 1
				If Cur.GetColumnName(i) <> Null Then
					If Cur.GetColumnName(i) = column Then
						results = Cur.GetString2(i)
						Exit
					End If
				End If
			Next
		End If
	End If
	
	Cur.Close
	
	Return results
End Sub
'Gets the Mime Type or file type
'URI = Uri string
Public Sub GetMimeType(uri As String) As String
	
	Dim cur As Cursor
	Dim Uri1 As Uri
	Dim cr As ContentResolver
	cr.Initialize("")
	
	Uri1.Parse(uri)
	cur = cr.Query(Uri1, Null, Null, Null, Null)
	
	cur.Position = 0
	Dim res As String
	'0 = (document_id) record ID
	'1 = (mime_type) image/jpeg
	'2 = (_display_name) full File name
	Try
		res = cur.GetString("mime_type")
	Catch
		'SharedMod.LogErrorToFile("clsFiles.GetMimeType", LastException)
		res = "ERROR:" & LastException
	End Try
	cur.Close
	
	Return res
	
End Sub

Public Sub GetFileName(FullPath As String) As String
		
	Dim Name As String
	Dim path As String
		
	If FullPath.SubString(FullPath.Length - 1) = "/" Then
		
		path = FullPath.SubString2(0, FullPath.Length - 1)
		Name = FullPath.SubString2(path.LastIndexOf("/")+ 1, path.Length)
		
	Else
		Name = FullPath.SubString(FullPath.LastIndexOf("/")+1)
	End If
	
	Return Name
	
End Sub
Public  Sub GetFileParentPath(Path As String) As String
	
	Dim Path1 As String
	Dim Path2 As String
	Dim L As Int
	
	If Path = "/" Then
		Return "/"
	End If
	
	If Path.SubString(Path.Length - 1) = "/" Then
		Path2 = Path.SubString2(0, Path.Length - 1)
	Else
		Path2 = Path
	End If
	
	L = Path2.LastIndexOf("/")

	If L = Path.Length - 1 Then
		'Strip the last slash
		Path1 = Path2.SubString2(0,L)
	Else
		Path1 = Path2
	End If
	
	L = Path2.LastIndexOf("/")
	If L = 0 Then
		L = 1
	End If
	
	Return Path1.SubString2(0,L)
End Sub
